commit dea05068da8cbd8cb9c9707aa8c3e432bd967e55
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Nov 3 16:40:26 2025 +0000

    fix constification
    
    Broken-by: 96f8f12e212b

diff --git a/src/src/exim.c b/src/src/exim.c
index df343b5a1..c6fa25fc7 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -5320,7 +5320,7 @@ if (verify_address_mode || f.address_test_mode)
       while (*s)
         {
         BOOL finished = FALSE;
-        uschar *ss = parse_find_address_end(s, FALSE);
+        uschar * ss = parse_find_address_end(s, FALSE);
         if (*ss == ',') *ss = 0; else finished = TRUE;
         test_address(s, flags, &exit_value);
         s = ss;
@@ -5875,7 +5875,7 @@ for (BOOL more = TRUE; more; )
       uschar * errmess;
       /* There can be multiple addresses, so EXIM_DISPLAYMAIL_MAX (tuned for 1) is too short.
       We'll still want to cap it to something, just in case. */
-      const uschar * s = string_copy_taint(
+      uschar * s = string_copy_taint(
 	exim_str_fail_toolong(list[i], BIG_BUFFER_SIZE, "address argument"),
 	GET_TAINTED);
 
diff --git a/src/src/functions.h b/src/src/functions.h
index 4801eb8b5..ef1c59dc3 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -398,7 +398,17 @@ extern uschar *parse_extract_address(const uschar *, uschar **, int *, int *, in
                  BOOL);
 extern int     parse_forward_list(const uschar *, int, address_item **, uschar **,
                  const uschar *, const uschar *, error_block **);
-extern uschar *parse_find_address_end(const uschar *, BOOL);
+
+extern const uschar * parse_find_address_end_gen(const uschar *, BOOL);
+static inline uschar * parse_find_address_end_nc(uschar * s, BOOL b)
+{ return US parse_find_address_end_gen(s, b); }
+static inline const uschar * parse_find_address_end_c(const uschar * s, BOOL b)
+{ return    parse_find_address_end_gen(s, b); }
+#define parse_find_address_end(X, B) _Generic((X),     \
+	      uschar *:		parse_find_address_end_nc, \
+	      const uschar *:	parse_find_address_end_c \
+	      )(X, B)
+
 extern const uschar *parse_find_at(const uschar *);
 extern const uschar *parse_fix_phrase(const uschar *, int);
 extern const uschar *parse_message_id(const uschar *, uschar **, uschar **);
diff --git a/src/src/miscmods/exim_filter.c b/src/src/miscmods/exim_filter.c
index 08124b3f7..21ede4ad5 100644
--- a/src/src/miscmods/exim_filter.c
+++ b/src/src/miscmods/exim_filter.c
@@ -2419,15 +2419,14 @@ while (commands)
 	  tt = to;
 	  while (*tt)
 	    {
-	    uschar * ss = parse_find_address_end(tt, FALSE), * errmess;
-	    const uschar * recipient;
+	    const uschar * ss = parse_find_address_end(tt, FALSE);
+	    const uschar * ttt, * recipient;
+	    uschar * errmess;
 	    int start, end, domain;
-	    int temp = *ss;
 
-	    *ss = 0;
-	    recipient = parse_extract_address(tt, &errmess,
+	    ttt = *ss ? string_copyn(tt, ss - tt) : tt;
+	    recipient = parse_extract_address(ttt, &errmess,
 					      &start, &end, &domain, FALSE);
-	    *ss = temp;
 
 	    /* Ignore empty addresses and errors; an error will occur later if
 	    there's something really bad. */
diff --git a/src/src/miscmods/sieve_filter.c b/src/src/miscmods/sieve_filter.c
index 38b408f1b..cb57fa11f 100644
--- a/src/src/miscmods/sieve_filter.c
+++ b/src/src/miscmods/sieve_filter.c
@@ -2036,7 +2036,7 @@ if (parse_identifier(filter, CUS "address"))
   for (gstring * h = hdr; h->ptr != -1 && !*cond; ++h)
     {
     const uschar * header_value = NULL;
-    uschar * extracted_addr, * end_addr;
+    uschar * extracted_addr;
 
     if (  !eq_asciicase(h, &str_from, FALSE)
        && !eq_asciicase(h, &str_to, FALSE)
@@ -2061,15 +2061,15 @@ if (parse_identifier(filter, CUS "address"))
       f.parse_allow_group = TRUE;
       while (*header_value && !*cond)
         {
-        uschar *error;
+        uschar * part = NULL, * error;
+	const uschar * end_addr, * ss;
         int start, end, domain;
-        int saveend;
-        uschar *part = NULL;
 
         end_addr = parse_find_address_end(header_value, FALSE);
-        saveend = *end_addr;
-        *end_addr = 0;
-        extracted_addr = parse_extract_address(header_value, &error, &start, &end, &domain, FALSE);
+	ss = *end_addr
+	  ? header_value : string_copyn(header_value, end_addr - header_value);
+        extracted_addr = parse_extract_address(ss, &error,
+						&start, &end, &domain, FALSE);
 
         if (extracted_addr) switch (addressPart)
           {
@@ -2084,7 +2084,6 @@ if (parse_identifier(filter, CUS "address"))
 #endif
           }
 
-        *end_addr = saveend;
         if (part && extracted_addr)
 	  {
 	  gstring partStr = {.s = part, .ptr = Ustrlen(part), .size = Ustrlen(part)+1};
@@ -2096,7 +2095,7 @@ if (parse_identifier(filter, CUS "address"))
             }
 	  }
 
-        if (saveend == 0) break;
+        if (*end_addr) break;
         header_value = end_addr + 1;
         }
       f.parse_allow_group = FALSE;
diff --git a/src/src/parse.c b/src/src/parse.c
index cdb1e0c1e..1fe4f70f8 100644
--- a/src/src/parse.c
+++ b/src/src/parse.c
@@ -68,8 +68,8 @@ Returns:   pointer past the end of the address
            (i.e. points to null or comma)
 */
 
-uschar *
-parse_find_address_end(const uschar * s, BOOL nl_ends)
+const uschar *
+parse_find_address_end_gen(const uschar * s, BOOL nl_ends)
 {
 BOOL source_routing = *s == '@';
 int no_term = source_routing ? 1 : 0;
@@ -129,7 +129,7 @@ while (*s && (*s != ',' || no_term > 0) && (*s != '\n' || !nl_ends))
     }
   }
 
-return US s;
+return s;
 }
 
 
diff --git a/src/src/verify.c b/src/src/verify.c
index a12e74ce6..1fee97150 100644
--- a/src/src/verify.c
+++ b/src/src/verify.c
@@ -2338,9 +2338,9 @@ Returns:     OK
 */
 
 int
-verify_check_headers(uschar **msgptr)
+verify_check_headers(uschar ** msgptr)
 {
-uschar *colon, *s;
+uschar * colon, * s;
 int yield = OK;
 
 for (header_line * h = header_list; h && yield == OK; h = h->next)
@@ -2639,8 +2639,7 @@ int yield = FAIL;
 for (int i = 0; i < 3 && !done; i++)
   for (const header_line * h = header_list; h && !done; h = h->next)
     {
-    const uschar * endname, * s;
-    uschar * ss;
+    const uschar * endname, * s, * ss, * es;
 
     if (h->type != header_types[i]) continue;
     s = endname = Ustrchr(h->text, ':') + 1;
@@ -2652,38 +2651,36 @@ for (int i = 0; i < 3 && !done; i++)
 
     while (*s)
       {
-      int terminator, new_ok;
+      int new_ok;
       address_item * vaddr;
 
       while (isspace(*s) || *s == ',') s++;
       if (!*s) break;			/* End of header */
 
-      ss = parse_find_address_end(s, FALSE);
+      es = parse_find_address_end(s, FALSE);
 
       /* The terminator is a comma or end of header, but there may be white
       space preceding it (including newline for the last address). Move back
       past any white space so we can check against any cached envelope sender
       address verifications. */
 
-      while (isspace(ss[-1])) ss--;
-      terminator = *ss;
-      *ss = '\0';
+      while (isspace(es[-1])) es--;
+      ss = *es ? string_copyn(s, es - s) : s;
 
       HDEBUG(D_verify) debug_printf("verifying %.*s header address %s\n",
-        (int)(endname - h->text), h->text, s);
+        (int)(endname - h->text), h->text, ss);
 
       /* See if we have already verified this address as an envelope sender,
       and if so, use the previous answer. */
 
-      vaddr = verify_checked_sender(s);
+      vaddr = verify_checked_sender(ss);
 
-      if (vaddr != NULL &&                   /* Previously checked */
-           (callout <= 0 ||                  /* No callout needed; OR */
-            vaddr->special_action > 256))    /* Callout was done */
+      if (   vaddr				/* Previously checked */
+          && (  callout <= 0			/* No callout needed; OR */
+	     || vaddr->special_action > 256))	/* Callout was done */
         {
         new_ok = vaddr->special_action & 255;
         HDEBUG(D_verify) debug_printf("previously checked as envelope sender\n");
-        *ss = terminator;  /* Restore shortened string */
         }
 
       /* Otherwise we run the verification now. We must restore the shortened
@@ -2693,9 +2690,8 @@ for (int i = 0; i < 3 && !done; i++)
       else
         {
         int start, end, domain;
-        const uschar * address = parse_extract_address(s, log_msgptr,
+        const uschar * address = parse_extract_address(ss, log_msgptr,
 						  &start, &end, &domain, FALSE);
-        *ss = terminator;
 
         /* If we found an empty address, just carry on with the next one, but
         kill the message. */
@@ -2703,7 +2699,7 @@ for (int i = 0; i < 3 && !done; i++)
         if (!address && Ustrcmp(*log_msgptr, "empty address") == 0)
           {
           *log_msgptr = NULL;
-          s = ss;
+          s = es;
           continue;
           }
 
@@ -2713,10 +2709,10 @@ for (int i = 0; i < 3 && !done; i++)
 
         if (!address)
           {
-          while (ss > s && isspace(ss[-1])) ss--;
+          while (es > s && isspace(es[-1])) es--;
           *log_msgptr = string_sprintf("syntax error in '%.*s' header when "
             "scanning for sender: %s in \"%.*s\"",
-            (int)(endname - h->text), h->text, *log_msgptr, (int)(ss - s), s);
+            (int)(endname - h->text), h->text, *log_msgptr, (int)(es - s), s);
           yield = FAIL;
           done = TRUE;
           break;
@@ -2759,7 +2755,7 @@ for (int i = 0; i < 3 && !done; i++)
 
       /* Move on to any more addresses in the header */
 
-      s = ss;
+      s = es;
       }     /* Next address */
 
     f.parse_allow_group = FALSE;

